use Mix.Config

config :aliyun_api, http_timeout: {:system, "HTTP_TIMEOUT", 10_000}
config :aliyun_api, http_recv_timeout: {:system, "HTTP_RECV_TIMEOUT", 8_000}

config :aliyun_api, :apps,
  default: %{
    email: %{
      endpoint: "dm.aliyuncs.com",
      access_key_id: "xxx",
      access_key_secret: "xxx",
      options: %{
        from_address: "service@email.xxx.com",
        from_alias: "xxx"
      }
    },
    vod: %{
      access_key_id: "xxx",
      access_key_secret: "xxx",
      endpoint: "vod.cn-shanghai.aliyuncs.com",
      signature_version: "1.0",
      version: "2017-03-21",
      categories: %{
        env_dev: "xxx",
        env_test: "xxx",
        env_prod: "xxx",
        env_staging: "xxx"
      },
      tags: %{
        env_prod: "生产环境",
        env_dev: "开发环境",
        env_test: "测试环境",
        usage_test: "用于测试"
      }
    },
    oss: %{
      access_key_id: "xxx",
      access_key_secret: "xxx",
      endpoint: "oss-cn-shanghai.aliyuncs.com",
      buckets: %{default: "xxx"}
    },
    sts: %{
      access_key_id: "xxx",
      access_key_secret: "xxx",
      endpoint: "sts.aliyuncs.com",
      signature_version: "1.0",
      version: "2015-04-01",
      arns: %{
        default_rw: "acs:ram::31910965:role/vod-oss-develop-for-write",
        default_r: "acs:ram::31910965:role/vod-oss-develop-for-read-only"
      }
    }
  }

if File.exists?("#{__DIR__}/#{Mix.env()}.exs") do
  import_config "#{Mix.env()}.exs"
end

if File.exists?("#{__DIR__}/#{Mix.env()}.secret.exs") do
  import_config "#{Mix.env()}.secret.exs"
end
