defmodule AliyunAPI.Env do
  def get_http_timeout do
    Application.get_env(:aliyun_api, :http_timeout)
    |> _get_value()
    |> to_string()
    |> String.to_integer()
  end

  def get_http_recv_timeout do
    Application.get_env(:aliyun_api, :http_recv_timeout)
    |> _get_value()
    |> to_string()
    |> String.to_integer()
  end

  ## Email相关 ##
  def email_endpoint(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :email, :endpoint])
    |> _get_value()
  end

  def email_access_key_id(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :email, :access_key_id])
    |> _get_value()
  end

  def email_access_key_secret(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :email, :access_key_secret])
    |> _get_value()
  end

  def email_opts(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :email, :options])
    |> _get_value()
  end

  ## STS相关 ##
  def sts_endpoint(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :endpoint])
    |> _get_value()
  end

  def sts_access_key_id(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :access_key_id])
    |> _get_value()
  end

  def sts_access_key_secret(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :access_key_secret])
    |> _get_value()
  end

  def sts_signature_version(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :signature_version])
    |> _get_value()
  end

  def sts_version(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :version])
    |> _get_value()
  end

  def sts_arns(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :sts, :arns])
    |> _get_value()
  end

  ## END STS相关 ##

  ## OSS相关 ##
  def oss_endpoint(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :oss, :endpoint])
    |> _get_value()
  end

  def oss_access_key_id(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :oss, :access_key_id])
    |> _get_value()
  end

  def oss_access_key_secret(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :oss, :access_key_secret])
    |> _get_value()
  end

  def oss_buckets(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :oss, :buckets])
    |> _get_value()
  end

  ## END OSS相关 ##

  ## VOD相关 ##
  def vod_endpoint(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :endpoint])
    |> _get_value()
  end

  def vod_access_key_id(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :access_key_id])
    |> _get_value()
  end

  def vod_access_key_secret(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :access_key_secret])
    |> _get_value()
  end

  def vod_signature_version(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :signature_version])
    |> _get_value()
  end

  def vod_tags(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :tags])
    |> _get_value()
  end

  def vod_categories(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :categories])
    |> _get_value()
  end

  def vod_version(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :version])
    |> _get_value()
  end

  def vod_region_id(app) do
    Application.get_env(:aliyun_api, :apps, [])
    |> get_in([app, :vod, :region_id])
    |> _get_value()
  end

  ## END VOD相关 ##

  defp _get_value({:system, system_key, default_value}) do
    _get_value({:system, system_key}) || default_value
  end

  defp _get_value({:system, system_key}) do
    System.get_env(system_key)
  end

  defp _get_value(other), do: other
end
