defmodule AliyunAPI.Mixfile do
  use Mix.Project

  def project do
    [app: :aliyun_api,
     version: "1.1.1",
     elixir: "~> 1.4",
     build_embedded: Mix.env == :prod,
     start_permanent: Mix.env == :prod,
     description: description(),
     package: package(),
     deps: deps()]
  end

  def application do
    [
      extra_applications: [:logger, :logger_file_backend, :timex]
    ]
  end

  defp deps do
    [
      {:melib, ">= 0.0.0"},
      {:timex, ">= 0.0.0"},
      {:logger_file_backend, ">= 0.0.0"},
      {:sweet_xml, ">= 0.0.0"},
      {:xml_builder, ">= 0.0.0"},
      {:jason, ">= 0.0.0"},
      {:httpoison, ">= 0.0.0"},
      {:ex_doc, ">= 0.0.0", only: :dev},
      {:confex, ">= 0.0.0"}
    ]
  end

  defp description do
    "Aliyun Utils"
  end

  defp package do
    [
      files: ["lib", "config", "priv", "mix.exs", "README.md"],
      maintainers: ["dev800 <dev800@ku800.com>"],
      licenses: ["MIT"],
      links: %{"GitHub": "https://github.com/dev800/aliyun_api_util.git"}
    ]
  end
end
